SystemOrganization addCategory: #'Xpf-Client-Tests'!
SystemOrganization addCategory: #'Xpf-Client-Morphs'!
SystemOrganization addCategory: #'Xpf-Client-Helpers'!
SystemOrganization addCategory: #'Xpf-Client-AdminTool'!

PasteUpMorph subclass: #XpfProjectMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfProjectMorph class methodsFor: 'initialize-release' stamp: 'topa 3/4/2009 00:08'!
forProject: anXpfProject

	^ self new model: anXpfProject! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'cs 2/26/2009 18:57'!
addUserStoryMorph: anXpfUserStoryMorph

	^ self addMorph:
		"Places new UserStories in the top left corner with 5 indent"
		(anXpfUserStoryMorph topLeft: (self submorphCount * 5 asPoint))! !

!XpfProjectMorph methodsFor: 'initialization' stamp: 'topa 3/3/2009 20:18'!
buildUserStorySubmorphs

	self model userStories do: [ :userStory| 
		self addUserStoryMorph: (XpfUserStoryMorph forUserStory: userStory)]! !

!XpfProjectMorph methodsFor: 'initialization' stamp: 'topa 3/4/2009 00:03'!
initialize

	super initialize.
	self acquireBorderWidth: 5.! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 12:14'!
model: anObject

	self removeAllMorphsIn: self userStorySubmorphs. 
	model := anObject.
	self buildUserStorySubmorphs.
! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 10:51'!
userStorySubmorphs

	^ self allMorphs select: [:aMorph| aMorph isUserStoryMorph]! !

XpfTestCase subclass: #XpfAdminToolTest
	instanceVariableNames: 'sut factoryMock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfAdminToolTest methodsFor: 'setup' stamp: 'mt 3/4/2009 13:46'!
setUp

	super setUp.
	sut := XpfAdminTool new.
	factoryMock := XpfProxyObjectFactoryMock new.
	sut initializeWith: factoryMock.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:40'!
testEditProjectTitle
	
	sut projectTitleEntry setText: 'testEditProjectTitle'.
	sut saveProjectButton performAction.
	
	self
		should: sut projectList selection = 'testEditProjectTitle';
		should: sut model projects first title = 'testEditProjectTitle'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:26'!
testGetAllProjects
	
	self
		should: sut projectList getList size = 1;
		should: sut projectList getList first = factoryMock getAllProjects first title.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 14:00'!
testGetAllUsers
	
	self
		should: sut userList getList size = 1;
		should: sut userList getList first = factoryMock getAllUsers first userName.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:06'!
testSelectProject
	
	sut projectList selection: factoryMock projectTitle.
	self
		should: sut projectList selectionIndex = 1;
		should: sut projectTitleEntry text = factoryMock projectTitle.! !

XpfTestCase subclass: #XpfClientTest
	instanceVariableNames: 'project userstory1 userstory2 sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfClientTest methodsFor: 'running' stamp: 'topa 3/4/2009 00:32'!
setUp

	super setUp.
	self setupFixtures.
	sut := XpfClient forProject: project.
! !

!XpfClientTest methodsFor: 'running' stamp: 'topa 3/4/2009 00:30'!
setupFixtures

	project := XpfProject new title: 'Test Project'.
	userstory1 := XpfUserStory new
				title: 'Test User Story with long title.';
				explanation: 'This is the explanantion of a user story.'.
	userstory2 := XpfUserStory new title: 'Test User Story'.
	project
		addUserStory: userstory1;
		addUserStory: userstory2! !

!XpfClientTest methodsFor: 'running' stamp: 'topa 3/4/2009 00:27'!
tearDown

	project
		removeUserStory: userstory1;
		removeUserStory: userstory2.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:35'!
testAddUSMorphsToProjectMorph

	| usMorphCount projectMorph |
	projectMorph := XpfProjectMorph new.
	usMorphCount := projectMorph userStorySubmorphs size.
	
	projectMorph addUserStoryMorph: (XpfUserStoryMorph forUserStory: userstory1).
	self should: projectMorph userStorySubmorphs size = (usMorphCount + 1).! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:32'!
testProjectTitleDisplay

 	self should: sut label = project printString.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:32'!
testUserStoryDetailWindow

	| sut2 |
	sut2 := XpfUserStoryDetailWindow forUserStory: userstory1.

	self
		should: sut2 titleText getText = userstory1 title
		description: 'The text entry should contain the title of the user story.'.
		
	self
		should: sut2 explanationText getText = userstory1 explanation
		description: 'The explanation is not correct'.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:33'!
testUserStoryDetailWindowOk

	| sut2 newTitle newExp |
	sut2 := XpfUserStoryDetailWindow forUserStory: userstory1.
	
	newTitle := 'Changed Text.'.
	newExp := 'Changed Explanation.'.

	sut2 titleText textMorph contents: newTitle.
	sut2 explanationText textMorph contents: newExp.
	
	self
		shouldnt: userstory1 title = newTitle;
		shouldnt: userstory1 explanation = newExp.
	sut2 ok.
	
	self
		should: userstory1 title = newTitle;
		should: userstory1 explanation = newExp.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:33'!
testUserStorySubmorphs

	| sut2 |
	sut2 := XpfProjectMorph forProject: project.

	self should: sut2 userStorySubmorphs size = project userStories size.

	sut2 userStorySubmorphs do: [ :usMorph| 
		self should: (project userStories includes: usMorph model)].! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:33'!
testUserStoryTextContent

	| sut2 titleMorph |
	sut2 := XpfUserStoryMorph forUserStory: userstory2.
	self should: sut2 submorphCount > 0.
	
	titleMorph := sut2 submorphs detect: [:submorph |
			submorph isTextMorph and: [submorph text asString = userstory2 printString]].
	self
		shouldnt: titleMorph isNil;
		should: (titleMorph wrapString startsWith: '<yes>');
	 	should: titleMorph width <= 100.! !

Object subclass: #XpfAdminToolModel
	instanceVariableNames: 'factory projects currentProjectIndex users currentUserIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-AdminTool'!

!XpfAdminToolModel class methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 20:19'!
newWithFactory: aFactory

	^ self new factory: aFactory! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
allProjectTitles

	^ self projects collect: [:project | project title]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 14:00'!
allUserNames

	^ self users collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:23'!
currentProjectIndex

	^ currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 16:57'!
currentProjectIndex: anObject

	currentProjectIndex := anObject.
	self
		changed: #currentProjectIndex;
		changed: #currentProjectTitle.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/4/2009 10:01'!
currentProjectTitle

	^ self allProjectTitles at: self currentProjectIndex ifAbsent: []! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
currentProjectTitle: aString

	(self projects at: self currentProjectIndex) title: aString.
	self
		changed: #currentProjectTitle;
		changed: #allProjectTitles.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 12:59'!
currentUserIndex
	^ currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:22'!
currentUserIndex: anObject

	currentUserIndex := anObject.
	self
		changed: #currentUserIndex;
		changed: #currentUserName.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:36'!
currentUserName

	^ self allUserNames at: self currentUserIndex ifAbsent: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 14:04'!
currentUserName: aString

	(self users at: self currentUserIndex) userName: aString.
	self
		changed: #currentUserName;
		changed: #allUserNames.! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:24'!
factory

	^ factory! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:24'!
factory: anObject

	factory := anObject.! !

!XpfAdminToolModel methodsFor: 'initialization' stamp: 'mt 3/4/2009 13:36'!
initialize

	super initialize.
	self
		currentProjectIndex: 1;
		currentUserIndex: 1.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:24'!
projects
	
	^ projects ifNil: [projects := factory getAllProjects]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:02'!
users

	^  users ifNil: [users := factory getAllUsers]! !

Object subclass: #XpfProxyObjectFactoryMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfProxyObjectFactoryMock methodsFor: 'add-remove' stamp: 'mt 3/2/2009 17:48'!
addProject: aProject

	^ aProject! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'cs 3/3/2009 15:40'!
getAllProjects

	^ {XpfProject new title: self projectTitle}! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:04'!
getAllUsers

	^ {XpfUser new login: self userLogin; userName: self userName}! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:39'!
projectTitle

	^ 'test project'! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 11:17'!
userLogin

	^ 'random.guy'! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:17'!
userName

	^ 'Random Guy'! !

PluggableDialogWindow subclass: #XpfAdminTool
	instanceVariableNames: 'projectList userList projectTitleEntry userNameEntry saveProjectButton saveUserButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-AdminTool'!

!XpfAdminTool class methodsFor: 'user interface' stamp: 'topa 3/4/2009 00:02'!
open

	| instance text factory |
	instance := self new.
	text := UITheme current 
				textEntryIn: instance
				text: 'Enter server connection'
				title: 'Connection'
				entryText: 'http://localhost:8082/'.
	factory := XpfProxyObjectFactory fromString: (text ifNil: [^ nil]).
	^ (instance initializeWith: factory) openInWorld! !

!XpfAdminTool methodsFor: 'user interface helper' stamp: 'mt 3/4/2009 14:30'!
createCol: someElements

	^ UITheme current newColumnIn: self for: someElements! !

!XpfAdminTool methodsFor: 'user interface helper' stamp: 'mt 3/4/2009 14:25'!
createHFiller

	^ (UITheme current newToolSpacerIn: self) hResizing: #spaceFill! !

!XpfAdminTool methodsFor: 'user interface helper' stamp: 'mt 3/4/2009 13:10'!
createLabel: aString

	^ UITheme current
		newLabelIn: self
		label: aString.! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/3/2009 17:18'!
createProjectListFor: aModel

	self projectList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectTitles
		selected: #currentProjectIndex
		changeSelected: #currentProjectIndex:
		getEnabled: nil
		help: 'Shows all projects.').
	^ self projectList! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 13:25'!
createProjectTitleEntryFor: myModel

	self projectTitleEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentProjectTitle
		set: #currentProjectTitle:
		class: String
		getEnabled: nil
		help: 'Enter a short descriptive title for this project.') maxLength: 100).
	^ self projectTitleEntry! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 14:32'!
createProjectsTabFor: myModel 

	| col row |
	col := self createCol: { 
		self createRow: {self createLabel: 'Title:'. self createProjectTitleEntryFor: myModel}.
		self createRow: {self createHFiller. self createSaveProjectButtonFor: myModel}}.
		
	row := self createRow: {
		self createProjectListFor: myModel.
		col}.
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 11:07'!
createQuitButton

	^ UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #ok
		arguments: nil
		getEnabled: nil
		label: 'Quit'
		help: 'Close the admin tool'! !

!XpfAdminTool methodsFor: 'user interface helper' stamp: 'mt 3/4/2009 14:30'!
createRow: someElements

	^ UITheme current newRowIn: self for: someElements! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 13:28'!
createSaveProjectButtonFor: myModel 

	self saveProjectButton: (UITheme current 
		newButtonIn: self
		for: self projectTitleEntry
		getState: nil
		action: #accept
		arguments: nil
		getEnabled: nil
		label: 'Save'
		help: 'Save changed project title').
	^ self saveProjectButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 13:29'!
createSaveUserButtonFor: myModel 

	self saveUserButton: (UITheme current 
		newButtonIn: self
		for: self userNameEntry
		getState: nil
		action: #accept
		arguments: nil
		getEnabled: nil
		label: 'Save'
		help: 'Save changed user data').
	^ self saveUserButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 13:20'!
createUserListFor: aModel

	self userList: (UITheme current
		newListIn: self
		for: aModel
		list: #allUserNames
		selected: #currentUserIndex
		changeSelected: #currentUserIndex:
		getEnabled: nil
		help: 'Shows all users.').
	^ self userList! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 13:34'!
createUserNameEntryFor: myModel

	self userNameEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserName
		set: #currentUserName:
		class: String
		getEnabled: nil
		help: 'Enter the name of the user.') maxLength: 100).
	^ self userNameEntry! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 14:34'!
createUsersTabFor: myModel

	| col row |
	col := self createCol: { 
		self createRow: {self createLabel: 'Name:'. self createUserNameEntryFor: myModel}.
		self createRow: {self createHFiller. self createSaveUserButtonFor: myModel}}.
		
	row := self createRow: {
		self createUserListFor: myModel.
		col}.
	
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'user interface helper' stamp: 'mt 3/4/2009 14:25'!
createVFiller

	^ (UITheme current newToolSpacerIn: self) vResizing: #spaceFill! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/4/2009 13:14'!
initializeUserInterface: myModel

	^ UITheme current
		newTabGroupIn: self for: {
			'Projects' -> (self createProjectsTabFor: myModel). 
			'Users' -> (self createUsersTabFor: myModel)}! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/4/2009 11:07'!
initializeWith: aFactory

	| myModel |
	myModel := XpfAdminToolModel newWithFactory: aFactory.
	self
		buttons: {self createQuitButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Project Management'! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList

	^ projectList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList: anObject

	projectList := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry
	^ projectTitleEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry: anObject
	projectTitleEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton
	^ saveProjectButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton: anObject
	saveProjectButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton
	^ saveUserButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton: anObject
	saveUserButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList
	^ userList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList: anObject
	userList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry
	^ userNameEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry: anObject
	userNameEntry := anObject! !

PluggableDialogWindow subclass: #XpfUserStoryDetailWindow
	instanceVariableNames: 'explanationText titleText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfUserStoryDetailWindow class methodsFor: 'instance creation' stamp: 'topa 3/3/2009 20:51'!
forUserStory: aUserStory

	^ self new initializeWith: aUserStory! !

!XpfUserStoryDetailWindow methodsFor: 'actions' stamp: 'cs 2/26/2009 19:09'!
close
	
	super close.
	self changed: #detailsClosed.! !

!XpfUserStoryDetailWindow methodsFor: 'initialization' stamp: 'topa 3/4/2009 00:05'!
createExplanationTextFor: aUserStory

	self explanationText: (UITheme current
		newTextEditorIn: self
		for: aUserStory
		getText: #explanation
		setText: #explanation:
		getEnabled: nil).
	^ self explanationText alwaysAccept: true
! !

!XpfUserStoryDetailWindow methodsFor: 'initialization' stamp: 'topa 3/4/2009 00:05'!
createLabel

	^ UITheme current
		newLabelIn: self
		label: 'Title:'! !

!XpfUserStoryDetailWindow methodsFor: 'initialization' stamp: 'topa 3/4/2009 00:06'!
createTitleTextFor: aUserStory

	self titleText: ((UITheme current
		newTextEntryIn: self
		for: aUserStory
		get: #title
		set: #title:
		class: String
		getEnabled: nil
		help: 'Enter a short descriptive title for this user story.') 
	maxLength: 100).
	^ self titleText! !

!XpfUserStoryDetailWindow methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:06'!
explanationText

	^ explanationText! !

!XpfUserStoryDetailWindow methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:06'!
explanationText: anObject

	explanationText := anObject.! !

!XpfUserStoryDetailWindow methodsFor: 'initialization' stamp: 'mt 2/26/2009 17:39'!
initializeWith: aUserStory

	| col row |	
	row := UITheme current newRowIn: self for: {
		self createLabel.
		self createTitleTextFor: aUserStory}.
		
	col := UITheme current newColumnIn: self for: {
		row.
		self createExplanationTextFor: aUserStory}.
		
	self
		contentMorph: col;
		model: aUserStory;
		addGrips;
		title: aUserStory title.! !

!XpfUserStoryDetailWindow methodsFor: 'actions' stamp: 'cs 2/26/2009 19:10'!
ok

	self titleText accept.
	self explanationText accept.	
	self changed: #detailsClosed.
	super ok.! !

!XpfUserStoryDetailWindow methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:07'!
titleText

	^ titleText! !

!XpfUserStoryDetailWindow methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:07'!
titleText: anObject

	titleText := anObject.! !

!Morph methodsFor: '*xpf-client' stamp: 'topa 3/3/2009 23:50'!
isUserStoryMorph

	^ false! !

Morph subclass: #XpfUserStoryMorph
	instanceVariableNames: 'model titleMorph enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:07'!
defaultBorderColor

	^ Color darkGray! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:07'!
defaultColor

	^ Color paleTan! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:07'!
defaultDisabledBorderColor

	^ Color gray! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:07'!
defaultDisabledColor

	^ Color veryVeryLightGray ! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:08'!
defaultDisabledTextColor

	^ Color darkGray! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:08'!
defaultExtent

	^ 100@60 ! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:08'!
defaultTextColor

	^ Color black! !

!XpfUserStoryMorph class methodsFor: 'initialize-release' stamp: 'topa 3/4/2009 00:08'!
forUserStory: anXpfUserStory

	^ self new model: anXpfUserStory! !

!XpfUserStoryMorph methodsFor: 'colorization' stamp: 'topa 3/4/2009 00:16'!
colorizeDisabled

	self 
		color: self class defaultDisabledColor;
		borderColor: self class defaultDisabledTextColor.
	self titleMorph color: self class defaultDisabledBorderColor.! !

!XpfUserStoryMorph methodsFor: 'colorization' stamp: 'topa 3/4/2009 00:15'!
colorizeEnabled

	self 
		color: self class defaultColor;
		borderColor: self class defaultBorderColor.
	self titleMorph color: self class defaultTextColor.! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'topa 3/3/2009 20:18'!
doubleClick: evt

	self enabled: false.
	(XpfUserStoryDetailWindow forUserStory: self model)
		addDependent: self;
		openInHand.! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'cs 2/26/2009 18:24'!
doubleClickTimeout: evt

	evt hand attachMorph: self.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 2/26/2009 18:07'!
enabled

	^ enabled! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:15'!
enabled: aBoolean

	(enabled := aBoolean)
		ifTrue: [self colorizeEnabled]
		ifFalse: [self colorizeDisabled].
! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'cs 2/26/2009 18:24'!
handlesMouseDown: evt

	self enabled ifTrue:
		[evt hand waitForClicksOrDrag: self event: evt].
	^ true! !

!XpfUserStoryMorph methodsFor: 'initialization' stamp: 'cs 2/26/2009 19:12'!
initialize

	super initialize.
	self
		extent: self class defaultExtent;
		titleMorph: TextMorph new lock;
		borderWidth: 2;
		enabled: true.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 3/4/2009 00:21'!
isUserStoryMorph

	^ true! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:21'!
model

	^ model! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:21'!
model: anObject

	model := anObject.
	self update: #newModel.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:21'!
titleMorph

	^ titleMorph! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:22'!
titleMorph: anObject

	titleMorph ifNotNil: [self removeMorph: titleMorph].
	titleMorph := anObject.
	self addMorph:( titleMorph topLeft: 4@2).! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'topa 3/4/2009 00:23'!
update: aSymbol

	aSymbol = #detailsClosed ifTrue: [self enabled: true].
	self titleMorph
		contents: (self model title truncateWithElipsisTo: 24);
		wrapFlag: true;
		extent: self class defaultExtent.! !

RestProxyObjectFactory subclass: #XpfProxyObjectFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfProxyObjectFactory methodsFor: 'add-remove' stamp: 'cs 2/27/2009 15:21'!
addProject: aProject 

	^ self addObject: 'projects/' with: aProject! !

!XpfProxyObjectFactory methodsFor: 'accessing' stamp: 'topa 3/3/2009 17:46'!
getAllProjects

	^ self getCollection: 'projects/'! !

!XpfProxyObjectFactory methodsFor: 'accessing' stamp: 'mt 3/4/2009 11:16'!
getAllUsers

	^ self getCollection: 'users/'! !

PluggableSystemWindow subclass: #XpfClient
	instanceVariableNames: 'projectMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfClient class methodsFor: 'as yet unclassified' stamp: 'topa 3/4/2009 00:02'!
forProject: anXpfProject

	^ self new
		model: anXpfProject;
		getLabelSelector: #title! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 3/3/2009 20:14'!
initialize

	super initialize.	
	self 
		projectMorph: XpfProjectMorph new;
		addMorph: self projectMorph 
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@0 corner: 0@0)).! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 3/3/2009 20:14'!
model: anXpfProject

	super model: anXpfProject.
	self projectMorph model: anXpfProject.! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 3/3/2009 20:13'!
projectMorph

	^ projectMorph! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:02'!
projectMorph: anObject

	projectMorph := anObject.! !

XpfRestTest subclass: #XpfModelToProxyTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'topa 3/4/2009 00:34'!
setUp
	
	| factory |
	super setUp.
	factory := XpfProxyObjectFactory fromString: self class url.
	proxy := factory getAllProjects first.! !

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'topa 3/4/2009 00:34'!
testTitle

	self should: proxy title = testProject title.
	
	proxy userStories with: testProject userStories do: 
		[:proxyUS :realUS |  self should: proxyUS title = realUS title].! !
